package ru.dbotthepony.kstarbound.lua

import ru.dbotthepony.kstarbound.lua.LuaState.Companion.LUA_NUMTYPES
import ru.dbotthepony.kstarbound.lua.LuaState.Companion.LUA_TBOOLEAN
import ru.dbotthepony.kstarbound.lua.LuaState.Companion.LUA_TFUNCTION
import ru.dbotthepony.kstarbound.lua.LuaState.Companion.LUA_TLIGHTUSERDATA
import ru.dbotthepony.kstarbound.lua.LuaState.Companion.LUA_TNIL
import ru.dbotthepony.kstarbound.lua.LuaState.Companion.LUA_TNONE
import ru.dbotthepony.kstarbound.lua.LuaState.Companion.LUA_TNUMBER
import ru.dbotthepony.kstarbound.lua.LuaState.Companion.LUA_TSTRING
import ru.dbotthepony.kstarbound.lua.LuaState.Companion.LUA_TTABLE
import ru.dbotthepony.kstarbound.lua.LuaState.Companion.LUA_TTHREAD
import ru.dbotthepony.kstarbound.lua.LuaState.Companion.LUA_TUSERDATA

enum class LuaType {
	NONE,
	NIL,
	BOOLEAN,
	LIGHTUSERDATA,
	NUMBER,
	STRING,
	TABLE,
	FUNCTION,
	USERDATA,
	THREAD,
	UMTYPES;

	companion object {
		fun valueOf(value: Int): LuaType {
			return when (value) {
				LUA_TNONE -> NONE
				LUA_TNIL -> NIL
				LUA_TBOOLEAN -> BOOLEAN
				LUA_TLIGHTUSERDATA -> LIGHTUSERDATA
				LUA_TNUMBER -> NUMBER
				LUA_TSTRING -> STRING
				LUA_TTABLE -> TABLE
				LUA_TFUNCTION -> FUNCTION
				LUA_TUSERDATA -> USERDATA
				LUA_TTHREAD -> THREAD
				LUA_NUMTYPES -> UMTYPES
				else -> throw RuntimeException("Invalid Lua type: $value")
			}
		}
	}
}
