
-- why not use _ENV anyway lol
self = self or {}

local LUA_HINT_NONE = 0
local LUA_HINT_ARRAY = 1
local LUA_HINT_OBJECT = 2

-- this replicates original engine code, but it shouldn't work in first place
local function __newindex(self, key, value)
	local nils = getmetatable(self).__nils

	-- If we are setting an entry to nil, need to add a bogus integer entry
	-- to the __nils table, otherwise need to set the entry *in* the __nils
	-- table to nil and remove it.

	-- TODO: __newindex is called only when assigning non-existing keys to values,
	-- TODO: as per Lua manual.
	-- TODO: Chucklefish weren't aware of this?

	if key == nil then
		nils[key] = true
	else
		nils[key] = nil
	end

	rawset(self, key, value)
end

function jobject()
	return setmetatable({}, {
		__newindex = __newindex,
		__nils = {},
		__typehint = LUA_HINT_OBJECT
	})
end

function jarray()
	return setmetatable({}, {
		__newindex = __newindex,
		__nils = {},
		__typehint = LUA_HINT_ARRAY
	})
end

local __print = __print

function print(...)
	local values = {...}

	for i, v in ipairs(values) do
		values[i] = tostring(v)
	end

	__print(table.concat(values, '\t'))
end
